
/*
 Copyright (C) 2003 Martin A. Olevitch
 Written by Martin A. Olevitch (marty@cosray.wustl.edu)

 This file is part of LDDL.

 LDDL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 LDDL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with LDDL, see the file COPYING; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* ds.h */

#ifndef _DS_H
#define _DS_H

static char *_DS_H_cvsid = "$Id: ds.h,v 1.1.1.1 2000/03/24 20:10:24 marty Exp $";

struct valstruct {
    union {
	unsigned char b;
	unsigned short s;
	lddl_u_long l;
	float f;
	double d;
    } u;
    int is_set;
};
typedef struct valstruct valstruct;

/* functions found in lddl.c */
void args_add(char *s);
void args_end(void);
void endian_set(int offset, int type, int value, int mask);
void evt_def(char *name);
void evt_kind_init(char *name);
void evt_kind_value(int offset, int type, int value, int mask);
void fatal(char *fmt, ...);
void group_end(void);
void group_init(char *name);
void keep_end(void);
void keep_start(void);
void newspec(int type, int cnt, char *from_var, char *to_var,
	int optional, valstruct *v, int mask, char *group_name,
	lddl_u_long bitand, int shiftr);
void print_evts (void);
void warning(char *fmt, ...);

int mitten_drin(void);	/* found in grammar.y */

#endif /* _DS_H */
