/*
 Copyright (C) 2003 Martin A. Olevitch
 Written by Martin A. Olevitch (marty@cosray.wustl.edu)

 This file is part of LDDL.

 LDDL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 LDDL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with LDDL, see the file COPYING; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* lddl.h 
 *
 * Marty Olevitch, Winter 2000
 */

#ifndef _LDDL_H
#define _LDDL_H

static char *_LDDL_H_cvsid = "$Id: lddl.h,v 1.4 2001/05/09 17:44:12 marty Exp $";

/* lddl_long by Patrick Allison, Oct '08 */
#ifdef USE_INT_FOR_LONG
    typedef int lddl_long;
    typedef unsigned int lddl_u_long;
#else
    typedef long lddl_long;
    typedef unsigned long lddl_u_long;
#endif

/* data item types */
#define LDDL_INT8	0	/* char */
#define LDDL_INT16	1	/* short */
#define LDDL_INT32	2	/* long */
#define LDDL_INT64	3	/* long long */
#define LDDL_FLOAT32	4	/* float */
#define LDDL_FLOAT64	5	/* double */
#define LDDL_GROUP	6	/* group of data items */

typedef int (*evt_cb)  (char *name, int argc, char **argv);
typedef int (*node_cb) (char *inp, char *swapp, int type, int count, int
    nbytes, int argc, char **argv, int native, char *group_name,
    char *evt_name);
typedef int (*group_cb)(int argc, char **argv,
    char *group_name, char *evt_name);

void lddl_set_buf_size(lddl_u_long val);
int lddl_return_duplicate_node(int yesno);
int lddl_return_modified_value(int yesno);
void lddl_set_pre_evt_func(evt_cb f);
void lddl_set_evt_func(evt_cb f);
void lddl_set_post_evt_func(evt_cb f);
void lddl_set_group_func(group_cb f);
void lddl_set_post_group_func(group_cb f);
void lddl_set_node_func(node_cb f);
void lddl_set_err_func(void (*f)(char *str));
void lddl_set_new_file_func(void (*f)(char *str));
int lddl_search_for_evt_start(int yesno);

void lddl_set_native(int native);
void lddl_start(char *fmtfile, int ninfiles, char **infilev, char *progname);
char *lddl_version(void);

#endif	/* _LDDL_H */
