
/*
 Copyright (C) 2003 Martin A. Olevitch
 Written by Martin A. Olevitch (marty@cosray.wustl.edu)

 This file is part of LDDL.

 LDDL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 LDDL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with LDDL, see the file COPYING; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* memmove.c */

#ifndef HAVE_MEMMOVE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char *cvsid = "$Id: memmove.c,v 1.1.1.1 2000/03/24 20:10:24 marty Exp $";

void *
memmove(char *s1, char *s2, size_t n)
{
    char *s1e, *s2e;
    char *tmp;

    s1e = s1 + n;
    s2e = s2 + n;
    if ((s1 < s2 && s1e < s2) || (s2 < s1 && s2e < s1)) {
	memcpy(s1, s2, n);
    } else {
	tmp = malloc(n);
	if (tmp == NULL) {
	    return NULL;
	}
	memcpy(tmp, s2, n);
	memcpy(s1, tmp, n);
	free(tmp);
    }
}
#endif
