
/*
 Copyright (C) 2003 Martin A. Olevitch
 Written by Martin A. Olevitch (marty@cosray.wustl.edu)

 This file is part of LDDL.

 LDDL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 LDDL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with LDDL, see the file COPYING; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* misc.c */

#include <stdlib.h>	/* malloc, exit */
#include <stdio.h>
#include <errno.h>
#include <string.h>

#include "misc.h"

static char *cvsid = "$Id: misc.c,v 1.2 2000/08/03 14:27:11 marty Exp $";

static int Linecnt = 1;

void
lineno_incr(void)
{
    Linecnt++;
}

int
lineno_get(void)
{
    return Linecnt;
}

void *
str_alloc(void *p, void *p2)
{
    void *ptr;
#ifndef REALLOC_NULL
    if (p == NULL) {
	ptr = malloc(strlen(p2) + 1);
    } else
#endif
	ptr = realloc(p, strlen(p2) + 1);

    if (ptr == NULL) {
	fprintf(stderr, "str_alloc: can't alloc (%s)\n", strerror(errno));
	exit(1);
    }
    return ptr;
}

void *
emalloc(size_t n)
{
    void *ptr;
    ptr = malloc(n);
    if (ptr == NULL) {
	fprintf(stderr, "emalloc: can't malloc (%s)\n", strerror(errno));
	exit(1);
    }
    return ptr;
}

void *
erealloc(void *p, size_t n)
{
    void *ptr;
#ifndef REALLOC_NULL
    if (p == NULL) {
	ptr = malloc(n);
    } else
#endif
	ptr = realloc(p, n);

    if (ptr == NULL) {
	fprintf(stderr, "erealloc: can't realloc (%s)\n", strerror(errno));
	exit(1);
    }
    return ptr;
}
